diff -up dovecot-2.4.1-4/src/auth/mech-gssapi.c.gssapi dovecot-2.4.1-4/src/auth/mech-gssapi.c
--- dovecot-2.4.1-4/src/auth/mech-gssapi.c.gssapi	2025-06-24 00:07:54.720275640 +0200
+++ dovecot-2.4.1-4/src/auth/mech-gssapi.c	2025-06-24 00:10:04.541651871 +0200
@@ -672,7 +672,7 @@ mech_gssapi_auth_initial(struct auth_req
 
 	if (data_size == 0) {
 		/* The client should go first */
-		auth_request_handler_reply_continue(request, NULL, 0);
+		auth_request_handler_reply_continue(request, uchar_empty_ptr, 0);
 	} else {
 		mech_gssapi_auth_continue(request, data, data_size);
 	}