--- src/lib-settings/settings-history.pl
+++ src/lib-settings/settings-history.pl
@@ -3,6 +3,7 @@
 use warnings;
 use version;
 use 5.010;
+use PerlIO::encoding;
 
 my ($input_path, $pro_edition) = ($ARGV[0], $ARGV[1]);
 