--- src/lib-sieve/plugins/extlists/ext-extlists-settings.h
+++ src/lib-sieve/plugins/extlists/ext-extlists-settings.h
@@ -12,7 +12,7 @@ struct ext_extlists_list_settings {
 
 	const char *name;
 	/* Maximum size of lookup value */
-	size_t max_lookup_size;
+	uoff_t max_lookup_size;
 
 	struct {
 		const char *name;
--- src/plugins/settings/pigeonhole-settings-dynamic.c
+++ src/plugins/settings/pigeonhole-settings-dynamic.c
@@ -69,7 +69,7 @@ struct ext_extlists_list_settings {
 
 	const char *name;
 	/* Maximum size of lookup value */
-	size_t max_lookup_size;
+	uoff_t max_lookup_size;
 
 	struct {
 		const char *name;